/***************************************************************************
                          tdb_dl.c  -  3D filesystem browser
                             -------------------
    begin                : Fri Feb 23 2001
    copyright            : (C) 2001 by Leander Seige
    email                : leander@hgb-leipzig.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/*
Everything here is released under the GPL (http://www.gnu.org/copyleft/gpl.html) and coded by Leander Seige.
I would like to develop this program myself so if you have bugreports, additional code, bugfixes,
suggestions, questions or something similar, please mail me: leander@hgb-leipzig.de .
*/
#include <math.h>

void tdb_gen_list(void)
{

/*  */
/* Main Display List */
/*  */

	glNewList(listName,GL_COMPILE);
/* drawing the objects aka files */
		for(help=root;help;help=help->next)
		{
			glPushMatrix();
			mx=help->posx;	mz=help->posz; my=help->posy;
			glTranslatef( mx, my, mz );

			if ( ((help->mode)&0x1F) == 1 || ((help->mode)&0x1F) == 11)
			{
				if ((help->mode)&0x20) glutSolidSphere(0.5,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL);
				else glutSolidSphere(1,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL);

			}
			else if ( ((help->mode)&0x1F) == 0 || ((help->mode)&0x1F) == 10)
			{
				if ( (help->regtype==1) && ((help->mode)&0x1F)==0)
				{
                                        if ((help->mode)&0x20)
                                        {       glTranslatef(0,-my,0);
                                                if (help->scalex > help->scaley)
                                                {
                                                        if (help->scalex > help->scalez)
                                                        glScalef(0.5,0.5*(help->scaley)/(help->scalex),0.5*(help->scalez)/(help->scalex)); /* x am groessten */
                                                        else
                                                        glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
                                                }
                                                else if (help->scaley > help->scalez)
                                                        glScalef(0.5*(help->scalex)/(help->scaley),0.5,0.5*(help->scalez)/(help->scaley));  /* y am groessten */
                                                else
                                                        glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
                                        }
                                        else  glScalef(help->scalex,help->scaley,help->scalez);

					glEnable(GL_TEXTURE_2D); glBindTexture(GL_TEXTURE_2D,help->uniint3);
					if (TDFSB_ICUBE)	glDrawArrays(GL_QUADS, 0, 20); else  glDrawArrays(GL_QUADS, 0, 4);
					glDisable(GL_TEXTURE_2D);
				}
				else if (help->regtype!=2)
				{
                                        if ((help->mode)&0x20)
                                        {       glTranslatef(0,-my,0);
                                                if (help->scalex > help->scaley)
                                                {
                                                        if (help->scalex > help->scalez)
                                                        glScalef(0.5,0.5*(help->scaley)/(help->scalex),0.5*(help->scalez)/(help->scalex)); /* x am groessten */
                                                        else
                                                        glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
                                                }
                                                else if (help->scaley > help->scalez)
                                                glScalef(0.5*(help->scalex)/(help->scaley),0.5,0.5*(help->scalez)/(help->scaley));  /* y am groessten */
                                                else
                                                glScalef(0.5*(help->scalex)/(help->scalez),0.5*(help->scaley)/(help->scalez),0.5);  /* z am groessten */
                                        }
                                        else glScalef(help->scalex, help->scaley, help->scalez);
                                        glutSolidCube(2);
                                }


			}
			else
			{
				if ((help->mode)!=0x25)
				{
					if (((help->mode)&0x20))	glScalef(0.5,0.5,0.5);
					glutSolidOctahedron();
				}
			}
			glPopMatrix();
		}
/* drawing the ground grid */
		glPushMatrix();
		glDisable (GL_LIGHTING);
		glColor4f(TDFSB_GG_R,TDFSB_GG_G,TDFSB_GG_B,1.0);

                for (c1=0;c1<=20;c1++)
		{
			glBegin(GL_LINES);
				glVertex3f (	TDFSB_MINX+TDFSB_STEPX*c1,	-1,	TDFSB_MINZ);
				glVertex3f (	TDFSB_MINX+TDFSB_STEPX*c1,	-1,	TDFSB_MAXZ);
				glVertex3f (	TDFSB_MINX,			-1,	TDFSB_MINZ+TDFSB_STEPZ*c1);
				glVertex3f (	TDFSB_MAXX,			-1,	TDFSB_MINZ+TDFSB_STEPZ*c1);
			glEnd();
		}

		glEnable (GL_LIGHTING);
		glPopMatrix();
	glEndList();

/*  */
/* Display List Transparente Objekte 	*/
/*  */

	glNewList(listName+1,GL_COMPILE);
		glEnable (GL_LIGHTING);
		glEnable(GL_BLEND); glDepthMask(GL_FALSE); glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		for(help=root;help;help=help->next)
		{	mx=help->posx;	mz=help->posz; my=help->posy;
			if (( (help->regtype==2) && ((help->mode)&0x1F)==0))
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_yel);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_yel);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_yel);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_yel);
    			        glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_yel);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_yel);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_yel);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_yel);
					glPushMatrix();
                                                if ( ((help->mode)&0x20)) { glTranslatef(mx,0,mz); glScalef(0.25,0.55,0.25);glColor3f(0.8, 0.8, 0); glRotatef(90,1,0,0); }
					        else { glTranslatef(mx,3.5,mz); glScalef(help->scalex, 4.5, help->scalez); glColor3f(0.8, 0.8, 0); glRotatef(90,1,0,0); }
						glCallList(CylinderObj);
					glPopMatrix();
			}
			if ( ((help->mode)&0x1F) >= 10)
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_red);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_red);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_red);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_red);
    			        glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_red);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_red);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_red);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_red);
			 		glPushMatrix();
                                        if (((help->mode)&0x20)) { glTranslatef(help->posx, 0.2, help->posz); glScalef(1.2, 1.2, 1.2); }
			 		else                     { glTranslatef(help->posx, help->posy+.25, help->posz); glScalef((help->scalex)+.25,(help->scaley)+.25,(help->scalez)+.25); }
                                        glutSolidCube(2); glPopMatrix();
			}
			if ( ((help->mode)&0x20))
			{
				glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse_gry);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient_gry);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular_gry);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission_gry);
    			        glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse_gry);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient_gry);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular_gry);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission_gry);
			 		glPushMatrix(); glTranslatef(mx, 0, mz); if ((help->mode)==0x25) glutSolidSphere(0.5,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL); glutSolidSphere(1,TDFSB_BALL_DETAIL,TDFSB_BALL_DETAIL); glPopMatrix();
			}
		}
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);glMaterialfv(GL_FRONT, GL_EMISSION, mat_emission);
	glMaterialfv(GL_BACK, GL_DIFFUSE, mat_diffuse);glMaterialfv(GL_BACK, GL_AMBIENT, mat_ambient);glMaterialfv(GL_BACK, GL_SPECULAR, mat_specular);glMaterialfv(GL_BACK, GL_EMISSION, mat_emission);
	glDepthMask(GL_TRUE);glDisable(GL_BLEND);
	glDisable(GL_LIGHTING);
	glEndList();
}


void set_filetypes(void)
{
	xsuff[ 0]="ERRR";					tsuff[ 0]=0;
	xsuff[ 1]=".jpeg";				        tsuff[ 1]=1;
	xsuff[ 2]=".JPEG";				        tsuff[ 2]=1;
	xsuff[ 3]=".jpg";					tsuff[ 3]=1;
	xsuff[ 4]=".JPG";					tsuff[ 4]=1;
	xsuff[ 5]=".jpe";					tsuff[ 5]=1;
	xsuff[ 6]=".JPE";					tsuff[ 6]=1;
	xsuff[ 7]=".gif";					tsuff[ 7]=1;
	xsuff[ 8]=".GIF";					tsuff[ 8]=1;
	xsuff[ 9]=".tif";					tsuff[ 9]=1;
	xsuff[10]=".TIF";					tsuff[10]=1;
	xsuff[11]=".tiff";				        tsuff[11]=1;
	xsuff[12]=".TIFF";			        	tsuff[12]=1;
	xsuff[13]=".png";					tsuff[13]=1;
	xsuff[14]=".PNG";					tsuff[14]=1;
	xsuff[15]=".bmp";					tsuff[15]=1;	/* .pnm */
	xsuff[16]=".BMP";					tsuff[16]=1;	/* .PNM */
	xsuff[17]=".ras";					tsuff[17]=1;
	xsuff[18]=".RAS";					tsuff[18]=1;
	xsuff[19]=".ico";					tsuff[19]=1;
	xsuff[20]=".ICO";					tsuff[20]=1;
	xsuff[21]=".bmp";					tsuff[21]=1;
	xsuff[22]=".BMP";					tsuff[22]=1;
	xsuff[23]=".txt";					tsuff[23]=2;
	xsuff[24]=".TXT";					tsuff[24]=2;
	xsuff[25]=".c";						tsuff[25]=2;
	xsuff[26]=".C";						tsuff[26]=2;
	xsuff[27]=".h";						tsuff[27]=2;
	xsuff[28]=".htm";					tsuff[28]=2;
	xsuff[29]=".html";			        	tsuff[29]=2;
	xsuff[30]=".HTM";					tsuff[30]=2;
	xsuff[31]=".HTML";		        		tsuff[31]=2;
	xsuff[32]=".pl";					tsuff[32]=2;
	xsuff[33]="README";			        	tsuff[33]=2;
	xsuff[34]="LICENSE";		                	tsuff[34]=2;
	xsuff[35]="LICENSE-GPL";	                        tsuff[35]=2;
	xsuff[36]="LICENSE-LGPL";               	        tsuff[36]=2;
	xsuff[37]=".src";					tsuff[37]=2;
	xsuff[38]=".SRC";					tsuff[38]=2;
	xsuff[39]=".asc";					tsuff[39]=2;
	xsuff[40]=".ascii";     				tsuff[40]=2;
	xsuff[41]=".ASCII";	        			tsuff[41]=2;
	xsuff[42]=".ASC";					tsuff[42]=2;
	xsuff[43]=".sgml";		        		tsuff[43]=2;
	xsuff[44]=".SGML";			        	tsuff[44]=2;
	xsuff[45]=".java";				        tsuff[45]=2;
	xsuff[46]=".JAVA";			        	tsuff[46]=2;
        xsuff[47]=".tdfsb";                                     tsuff[47]=2;
        xsuff[48]="COPYING";                                    tsuff[48]=2;
        xsuff[49]=".xawtv";                                     tsuff[49]=2;
        xsuff[50]=".bash_history";                               tsuff[50]=2;

	nsuff[0]="UNKNOWN";
	nsuff[1]="PICTURE";
	nsuff[2]="TEXT";

}

void setup_kc(void)
{
        TDFSB_KC_FLY=  ' ';
        TDFSB_KC_HELP= 'h';
        TDFSB_KC_HOME= '0';
        TDFSB_KC_FS=   'f';
        TDFSB_KC_DOT=  '.';
        TDFSB_KC_RELM= 'r';
        TDFSB_KC_RL=   'l';
        TDFSB_KC_CDU=  'u';
        TDFSB_KC_IMBR= 'b';
        TDFSB_KC_INFO= 'i';
        TDFSB_KC_DISP= 'd';
        TDFSB_KC_CRH=  'c';
        TDFSB_KC_FPS=  'p';
        TDFSB_KC_GCR=  'g';
        TDFSB_KC_SHD=  'm';
        TDFSB_KC_NAME= 't';
        TDFSB_KC_SORT= 'a';
        TDFSB_KC_CLASS='o';
        TDFSB_KC_UP=   '2';
        TDFSB_KC_DOWN= 'w';
        TDFSB_KC_LEFT= 'q';
        TDFSB_KC_RIGHT='e';
        TDFSB_KC_SAVE= 's';
        TDFSB_KC_FTH=  '#';
}

void setup_help(void)
{
        help_str  = (char*) malloc (1024*sizeof(char));
        help_copy = (char*) malloc (1024*sizeof(char));
        tmpstr = (char*) malloc (48);

        strcat (help_str,"Esc           quit   F1/F2    speed +/-\n");
        strcat (help_str,"Mouse move    look   F3/F4      rot +/-\n");
        strcat (help_str,"UP         forward   F5/F6  ball detail\n");
        strcat (help_str,"DOWN      backward   HOME     start pos\n");
        strcat (help_str,"L/R     step aside   LMB  select object\n");
        strcat (help_str,"END    ground zero   +RMB approach obj.\n");

        sprintf(tmpstr,   "\"%c\"      filenames   \"%c\"   ground cross\n",TDFSB_KC_NAME,TDFSB_KC_GCR);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"      crosshair   \"%c\"        display\n",TDFSB_KC_CRH,TDFSB_KC_DISP);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"      dot files   \"%c\"      print FPS\n",TDFSB_KC_DOT,TDFSB_KC_FPS);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\" rel./get mouse   \"%c\"     fullscreen\n",TDFSB_KC_RELM,TDFSB_KC_FS);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"     reload dir   \"%c\"   image bricks\n",TDFSB_KC_RL,TDFSB_KC_IMBR);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"           cd..   \"%c\"      alphasort\n",TDFSB_KC_CDU,TDFSB_KC_SORT);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"        shading   \"%c\"         flying\n",TDFSB_KC_SHD,TDFSB_KC_FLY);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"      show help   \"%c\"  print GL info\n",TDFSB_KC_HELP,TDFSB_KC_INFO);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"      jump home   \"%c\"    classic nav\n",TDFSB_KC_HOME,TDFSB_KC_CLASS);
        strcat (help_str,tmpstr);

        sprintf(tmpstr,   "\"%c\"    save config   \"%c\"   fps throttle\n",TDFSB_KC_SAVE,TDFSB_KC_FTH);
        strcat (help_str,tmpstr);

        strcat (help_str,"                     F7/F8  max fps +/-\n");

        sprintf(tmpstr," \n\"%c|%c|%c|%c\"            Up|Down|Left|Right\n",TDFSB_KC_UP,TDFSB_KC_DOWN,TDFSB_KC_LEFT,TDFSB_KC_RIGHT);
        strcat (help_str,tmpstr);

        strcat (help_str,"PgUp/Down or MMB+Mouse move up/downward\n");
}



int setup_config(void)
{
        FILE *config;
        char conf_line[2048], conf_param[256], conf_value[1024], homefile[256];
        int x,y,zzz;

        strcpy(home,getenv("HOME"));
        strcpy(homefile,home);
        if (homefile[strlen(homefile)-1]=='/')  strcat(homefile,".tdfsb");
        else                                    strcat(homefile,"/.tdfsb");

        if (config=fopen(homefile,"r"))
        {
                printf("Reading %s ...\n",homefile);

                while (fgets(conf_line,256,config))
                {
                        if (strlen(conf_line)<4) { continue; }
                        x=0; while(conf_line[x]==' '||conf_line[x]=='\t')x++;  if(conf_line[x]=='#'||conf_line[x]=='\n') { continue; }

                        x=0;
                        while(conf_line[x]==' '||conf_line[x]=='\t') x++;
                                y=0;
                        while(conf_line[x]!=' '&&conf_line[x]!='='&&conf_line[x]!='\t'&&conf_line[x]!='\n') { conf_param[y++]=conf_line[x++]; }
                                conf_param[y]='\0';
                        while(conf_line[x]==' '||conf_line[x]=='='||conf_line[x]=='\t') x++;
                                y=0;
                        while(conf_line[x]!=' '&&conf_line[x]!='\t'&&conf_line[x]!='\n') { conf_value[y++]=conf_line[x++]; }
                                conf_value[y]='\0';
                                zzz=x;

                        if (strlen(conf_param)<1||strlen(conf_value)<1) continue;

                        for(x=0; x<paracnt; x++)        if(!strncmp(param[x],conf_param,strlen(param[x])))

                        if (type[x]==1)
                                { *(int *)value[x]=atoi(conf_value); printf(" * Read \"%d\" for %s\n",  *(int *)value[x], param[x]); }
                        else if (type[x]==2)
                                { strcpy((char *)value[x],conf_value); printf(" * Read \"%s\" for %s\n",(char *)value[x], param[x]); }
                        else if (type[x]==3)
                        {       *(GLfloat *)value[x]=(GLfloat)atof(conf_value);
                                printf(" * Read \"%f\" for %s\n",  *(GLfloat *)value[x], param[x]);
                        }
                        else if (type[x]==4)
                        {       if ((!strcmp("yes",conf_value))||(!strcmp("on",conf_value))||(!strcmp("1",conf_value))||(!strcmp("true",conf_value)))
                                        *(GLint *)value[x]=1;
                                else
                                        *(GLint *)value[x]=0;
                                printf(" * Read \"%d\" for %s\n",*(GLint *)value[x], param[x]);
                        }
                        else if (type[x]==5)
                        {
                                if (strlen(conf_value)==3)
                                {       if(conf_value[0]=='"' && conf_value[2]=='"' && isgraph(conf_value[1]) )
                                                for(x=0; x<TDFSB_KEYLIST_NUM; x++)
                                                        if(!strcmp(TDFSB_KEYLIST_NAMES[x],conf_param))
                                                                { *TDFSB_KEYLIST[x]=conf_value[1];
                                                                   printf(" * Read \"%c\" for %s\n",*TDFSB_KEYLIST[x],TDFSB_KEYLIST_NAMES[x]);
                                                                }
                                }
                                else if ( strlen(conf_value)==1 && strlen(conf_line)>(zzz+1) )
                                {       if ( conf_value[0]=='"' && conf_line[zzz]==' ' && conf_line[zzz+1]=='"' )
                                                for(x=0; x<TDFSB_KEYLIST_NUM; x++)
                                                        if(!strcmp(TDFSB_KEYLIST_NAMES[x],conf_param))
                                                                { *TDFSB_KEYLIST[x]=' ';
                                                                   printf(" * Read \"%c\" for %s\n",*TDFSB_KEYLIST[x],TDFSB_KEYLIST_NAMES[x]);
                                                                }
                                }
                        }

                }

                fclose (config);

                printf(" * some values may be truncated later if out of range\n");

                if (TDFSB_BALL_DETAIL<4) TDFSB_BALL_DETAIL=4;
                if (TDFSB_FPS_CONFIG)
                {
                        if(TDFSB_FPS_CONFIG<1)  { TDFSB_FPS_CONFIG=0; TDFSB_US_RUN=0; }
                        else                    { TDFSB_US_RUN=1000000/TDFSB_FPS_CONFIG; }
                }

                TDFSB_FPS_REAL=TDFSB_FPS_CACHE=TDFSB_FPS_CONFIG;

                mousespeed=(GLfloat) ceilf(mousespeed);
                headspeed= (GLfloat)(ceilf(headspeed*10)/10);

                if (mousespeed>20) mousespeed=20;
                else if (mousespeed<1) mousespeed=1;
                if (headspeed>2.0) headspeed=2.0;
                else if (headspeed<0.1) headspeed=0.1;

                if(TDFSB_BG_R>1.0) { TDFSB_BG_R=1.0; } else if(TDFSB_BG_R<0.0) { TDFSB_BG_R=0.0; }
                if(TDFSB_BG_G>1.0) { TDFSB_BG_G=1.0; } else if(TDFSB_BG_G<0.0) { TDFSB_BG_G=0.0; }
                if(TDFSB_BG_B>1.0) { TDFSB_BG_B=1.0; } else if(TDFSB_BG_B<0.0) { TDFSB_BG_B=0.0; }
                if(TDFSB_GG_R>1.0) { TDFSB_GG_R=1.0; } else if(TDFSB_GG_R<0.0) { TDFSB_GG_R=0.0; }
                if(TDFSB_GG_G>1.0) { TDFSB_GG_G=1.0; } else if(TDFSB_GG_G<0.0) { TDFSB_GG_G=0.0; }
                if(TDFSB_GG_B>1.0) { TDFSB_GG_B=1.0; } else if(TDFSB_GG_B<0.0) { TDFSB_GG_B=0.0; }
                if(TDFSB_FN_R>1.0) { TDFSB_FN_R=1.0; } else if(TDFSB_FN_R<0.0) { TDFSB_FN_R=0.0; }
                if(TDFSB_FN_G>1.0) { TDFSB_FN_G=1.0; } else if(TDFSB_FN_G<0.0) { TDFSB_FN_G=0.0; }
                if(TDFSB_FN_B>1.0) { TDFSB_FN_B=1.0; } else if(TDFSB_FN_B<0.0) { TDFSB_FN_B=0.0; }

                if (TDFSB_MAX_TEX_SIZE) { for (cc=1; cc<=TDFSB_MAX_TEX_SIZE; cc*=2); TDFSB_MAX_TEX_SIZE=cc/2; }
                if (startdir[0]!='/') strcpy(startdir,"/");

                for (x=0; x<TDFSB_KEYLIST_NUM-1; x++)
                {       for (y=x+1; y<TDFSB_KEYLIST_NUM; y++)
                                if (*TDFSB_KEYLIST[x]==*TDFSB_KEYLIST[y])
                                {       TDFSB_ALERT_KC=1000;
                                        printf("MALFORMED KEYBOARD MAP: %s conflicts with %s\n",TDFSB_KEYLIST_NAMES[x],TDFSB_KEYLIST_NAMES[y]);
                                }
                }

                if (TDFSB_ALERT_KC) setup_kc();

                return 0;
        }
        else
        {
                printf("couldn't open config file\n");
                printf("creating config file\n");
                if (config=fopen(homefile,"w"))
                {
                        fprintf(config,"# TDFSB Example Config File\n\n");
                        for (x=0; x<paracnt; x++)
                                if (type[x]!=5) fprintf(config,"%-18s = %-6s # %s\n",param[x],pdef[x],comment[x]);

                        fprintf(config,"\n# Key bindings\n\n");
                        for (x=0; x<TDFSB_KEYLIST_NUM; x++)
                                fprintf(config,"%-18s = \"%c\"\n",TDFSB_KEYLIST_NAMES[x],*TDFSB_KEYLIST[x]);

                        fclose (config);
                }
                else
                        printf("couldn't create config file\n");

                return 1;
        }
}


void save_config(void)
{
        FILE *config;
        char conf_line[2048], conf_param[256], conf_value[1024], homefile[256];
        int x,y,zzz;

        strcpy(home,getenv("HOME"));
        strcpy(homefile,home);
        if (homefile[strlen(homefile)-1]=='/')  strcat(homefile,".tdfsb");
        else                                    strcat(homefile,"/.tdfsb");

        if (config=fopen(homefile,"w"))
        {
                fprintf(config,"# TDFSB Saved Config File\n\n");
                for (x=0; x<paracnt; x++)
                {       if (type[x]==1) fprintf(config,"%-18s = %-6d \t# %s\n",param[x],*(int *)value[x],comment[x]);
                        else if (type[x]==2) fprintf(config,"%-18s = %s \t# %s\n",param[x],(char *)value[x],comment[x]);
                        else if (type[x]==3) fprintf(config,"%-18s = %f \t# %s\n",param[x],*(GLfloat *)value[x],comment[x]);
                        else if (type[x]==4) fprintf(config,"%-18s = %s \t# %s\n",param[x],*(int *)value[x]?"yes":"no",comment[x]);
                }

                fprintf(config,"\n# Key bindings\n\n");
                for (x=0; x<TDFSB_KEYLIST_NUM; x++)
                        fprintf(config,"%-18s = \"%c\"\n",TDFSB_KEYLIST_NAMES[x],*TDFSB_KEYLIST[x]);

                fclose (config);
        }
        else
                printf("couldn't create config file\n");


}